"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.operationPart = void 0;
const compoundPart_1 = require("./compoundPart");
const Utility_1 = require("typescript-dotnet-commonjs/System/Text/Utility");
const dictionaryObject_1 = require("../../utils/dictionaryObject");
const utils_1 = require("./../utils");
class operationPart extends compoundPart_1.compoundPart {
    constructor() {
        super(...arguments);
        this.ObjectCache1 = undefined;
        this.ObjectCache2 = undefined;
    }
    get subParts() {
        let lst = [];
        lst.push(this.parameter1);
        lst.push(this.parameter2);
        return lst;
    }
    get simpleName() {
        return this.parameter2 != null ? this.parameter2.simpleName : this.parameter1.simpleName;
    }
    setOnCache(val, param) {
        const strKey = utils_1.utils.getKeyParamCache(param);
        if (strKey !== "")
            return new dictionaryObject_1.DictionaryObject().add(strKey, val);
        return undefined;
    }
    getOnCache(obj, param) {
        if (obj === undefined)
            return undefined;
        const strKey = utils_1.utils.getKeyParamCache(param);
        if (strKey !== "")
            return obj.getValue(strKey);
        return undefined;
    }
    resolve(expressionData, resolved, running, evaluateAllContexts = true, setValue = null) {
        var _a, _b;
        if ((this.operator != null)) {
            let val1 = undefined;
            let val2 = undefined;
            const cacheValue = this.getOnCache(this.ObjectCache1, this.parameter1);
            const cache2Value = this.getOnCache(this.ObjectCache2, this.parameter2);
            if (cacheValue !== undefined)
                val1 = cacheValue;
            else
                val1 = (_a = this.parameter1) === null || _a === void 0 ? void 0 : _a.resolve(expressionData, /* out */ resolved, /* running:*/ running, /* evaluateAllContexts:*/ evaluateAllContexts);
            if (cache2Value !== undefined)
                val2 = cache2Value;
            else
                val2 = (_b = this.parameter2) === null || _b === void 0 ? void 0 : _b.resolve(expressionData, /* out */ resolved, /* running:*/ running, /* evaluateAllContexts:*/ evaluateAllContexts);
            resolved.resolved = true;
            if (this.ObjectCache1 === undefined) {
                this.ObjectCache1 = this.setOnCache(val1, this.parameter1);
            }
            if (this.ObjectCache2 === undefined) {
                this.ObjectCache2 = this.setOnCache(val2, this.parameter2);
            }
            return this.operator.invoke([val1, val2]);
        }
        resolved.resolved = false;
        return undefined;
    }
    addSubPart(part) {
        if ((this.parameter2 == null)) {
            this.parameter2 = part;
            return true;
        }
        return false;
    }
    canAcceptMore() {
        return (this.parameter2 == null);
    }
    toString() {
        var _a;
        return Utility_1.format("{0} {1} {2}", this.parameter1, (_a = this.operator) === null || _a === void 0 ? void 0 : _a.name, this.parameter2);
    }
}
exports.operationPart = operationPart;
//# sourceMappingURL=operationPart.js.map