"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.switchPartData = void 0;
const utils_1 = require("../utils");
const outputVariables_1 = require("../../utils/outputVariables");
class switchPartData {
    constructor() {
        this.cases = [];
    }
    get Cases() {
        return this.cases;
    }
    get DefaultValue() {
        return this.defaultValue;
    }
    set DefaultValue(value) {
        this.defaultValue = value;
    }
    get NullValue() {
        return this.nullValue;
    }
    set NullValue(value) {
        this.nullValue = value;
    }
    forValue(expressionData, value, resolved) {
        var _a;
        resolved.resolved = true;
        let resultingExpression;
        if ((value === null || value === undefined)) {
            if ((this.nullValue != null)) {
                resultingExpression = this.nullValue;
            }
            else if ((this.defaultValue != null)) {
                resultingExpression = this.defaultValue;
            }
        }
        else {
            let matched;
            this.cases.forEach((keyPart) => {
                let subResolved = new outputVariables_1.outputVariables();
                const reKey = keyPart.key;
                let key = reKey.resolve(expressionData, subResolved, undefined);
                if ((subResolved.resolved
                    && ((key != null)
                        && utils_1.utils.compare(key, value, '=')))) {
                    matched = keyPart.key;
                }
            });
            if ((matched != null)) {
                resultingExpression = (_a = this.cases.find((f) => f.key === matched)) === null || _a === void 0 ? void 0 : _a.value;
            }
            else if ((this.defaultValue != null)) {
                resultingExpression = this.defaultValue;
            }
        }
        if ((resultingExpression != null)) {
            return resultingExpression.resolve(expressionData, resolved, undefined);
        }
        else {
            resolved.resolved = false;
            return value;
        }
    }
}
exports.switchPartData = switchPartData;
//# sourceMappingURL=switchPartData.js.map