"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.invalidParametersException = void 0;
const badExpressionException_1 = require("./badExpressionException");
const Utility_1 = require("typescript-dotnet-commonjs/System/Text/Utility");
class invalidParametersException extends badExpressionException_1.badExpressionException {
    constructor(methodName, minParams, maxParams) {
        super(invalidParametersException.getErrorString(methodName, minParams, maxParams));
    }
    static getErrorString(methodName, minParams, maxParams) {
        if ((minParams == maxParams)) {
            if ((minParams == 0)) {
                return Utility_1.format("Function '{0}' does not take parameters", methodName);
            }
            else {
                return Utility_1.format("Function '{0}' requires {1} parameter(s)", methodName, minParams);
            }
        }
        else if (((minParams == -1)
            && (maxParams > 0))) {
            return Utility_1.format("Function '{0}' can not take more than {1} parameter(s)", methodName, maxParams);
        }
        else if (((maxParams == -1)
            && (minParams > 0))) {
            return Utility_1.format("Function '{0}' takes at least {1} parameter(s)", methodName, minParams);
        }
        return Utility_1.format("Invalid number of parameters for Function '{0}' should be between {1} - {2}", minParams, maxParams);
    }
}
exports.invalidParametersException = invalidParametersException;
//# sourceMappingURL=invalidParametersException.js.map