"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.aggregateFunction = void 0;
const invalidParametersException_1 = require("./../error/invalidParametersException");
const expressionCompiler_1 = require("../compiler/expressionCompiler");
class aggregateFunction {
    get FunctionName() {
        return typeof this;
    }
    /* virtual */ get minParameters() {
        return 1;
    }
    /* virtual */ get maxParameters() {
        return 1;
    }
    compileParameters(paramList, flags) {
        if ((((this.minParameters > 0)
            && (paramList.count < this.minParameters))
            || ((this.maxParameters >= 0)
                && (paramList.count > this.maxParameters)))) {
            throw new invalidParametersException_1.invalidParametersException(this.FunctionName, this.minParameters, this.maxParameters);
        }
        let parameters = [];
        for (let item of paramList.toArray()) {
            parameters.push(expressionCompiler_1.expressionCompiler.compile(item, undefined, undefined, flags));
        }
        return parameters;
    }
    /* internal */ invoke(expressionData, current, running, parameters, /* out */ resolved) {
        return this.invokeIteration(expressionData, current, running, parameters, /* out */ resolved);
    }
}
exports.aggregateFunction = aggregateFunction;
//# sourceMappingURL=aggregateFunction.js.map