"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.eval1 = exports.percent = exports.Bool = void 0;
const expressionCompiler_1 = require("./../../compiler/expressionCompiler");
const typeMapper_1 = require("./../../types/typeMapper");
const mfunction_1 = require("./../mfunction");
const reflectionExtender_1 = require("../../utils/reflectionExtender");
class Bool extends mfunction_1.mfunction {
    /* internal */ /* override */ invoke(expressionData, parameters, /* out */ resolved, running) {
        if ((parameters.length > 0)) {
            let result = parameters[0].resolveGeneric(expressionData, /* out */ resolved, reflectionExtender_1.getType(Object), /* running:*/ running);
            return result;
        }
        resolved.resolved = false;
        return false;
    }
}
exports.Bool = Bool;
class percent extends mfunction_1.mfunction {
    /* override */ get minParameters() {
        return 1;
    }
    /* override */ get maxParameters() {
        return 2;
    }
    invoke(expressionData, parameters, /* out */ resolved, running) {
        let obj = expressionData.contexts.pop();
        let decimals = 2;
        if ((parameters.length > 0)) {
            let value = parameters[0].resolveGeneric(expressionData, resolved, reflectionExtender_1.getType(Number), running, true);
            if ((resolved
                && (obj != null))) {
                resolved.resolved = true;
                return value > 0 ? Math.round((typeMapper_1.typeMapper.toType1(obj) * (value / 100))) : 0.0;
            }
        }
        resolved.resolved = false;
        return obj;
    }
}
exports.percent = percent;
class eval1 extends mfunction_1.mfunction {
    /* override */ get minParameters() {
        return 1;
    }
    /* override */ get maxParameters() {
        return 2;
    }
    /* internal */ /* override */ invoke(expressionData, parameters, /* out */ resolved, running) {
        let obj = expressionData.contexts.peek();
        if ((parameters.length > 0)) {
            let value = parameters[0].resolve(expressionData, /* out */ resolved, /* running:*/ running);
            if (resolved && obj != null) {
                resolved.resolved = true;
                let newPart = expressionCompiler_1.expressionCompiler.compile(value, undefined, undefined, new expressionCompiler_1.compileFlags());
                let newValue = newPart.resolveGeneric(expressionData, resolved, reflectionExtender_1.getType(Object), running);
                if ((resolved.resolved
                    && (obj != null))) {
                    resolved.resolved = true;
                    return newValue;
                }
            }
        }
        resolved.resolved = false;
        return obj;
    }
}
exports.eval1 = eval1;
//# sourceMappingURL=evals.js.map