"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultTypeMapper = void 0;
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
const reflectionExtender_1 = require("../utils/reflectionExtender");
const utils_1 = require("../compiler/utils");
const DateTime_1 = require("typescript-dotnet-commonjs/System/Time/DateTime");
const TimeSpan_1 = require("typescript-dotnet-commonjs/System/Time/TimeSpan");
const general_1 = require("./../utils/general");
const outputVariables_1 = require("../utils/outputVariables");
const dictionaryObject_1 = require("../utils/dictionaryObject");
class defaultTypeMapper {
    toTypeGeneric(item, tType, success) {
        let result = this.toType(item, tType, success);
        if (success.resolved) {
            return result;
        }
        else {
            return this.nullToTypeGeneric(tType);
        }
    }
    //  /* virtual */ toType(item: Object, targetType: Type): Object | undefined{
    //     let success: boolean = true;
    //     let result = this.toType(item, targetType);
    //     if (success) {
    //         return result;
    //     }
    //     else {
    //         return this.nullToType(targetType);
    //     }
    // }
    toType(item, targetType, success) {
        //  If the targetType is not the same or the parent of the object type
        try {
            success.resolved = true;
            if (item != null && reflectionExtender_1.getType(item) != targetType && targetType instanceof Object) {
                if ((typeof targetType === 'string')) {
                    return item.toString();
                }
                else if (typeof targetType == 'number') {
                    if (utils_1.utils.IsNumericType(item)) {
                        if (general_1.isFloatType(item)) {
                            return Number.parseFloat(item);
                        }
                        else {
                            return Number.parseInt(item);
                        }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToInt16(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToInt32(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToInt64(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToByte(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToUInt16(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToUInt32(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToUInt64(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToDouble(item);
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     return Convert.ToSingle(item);
                        // }
                        // if ((targetType == typeof (number))) {
                        //     return Convert.ToDecimal(item);
                        // }
                        // else {
                        //     return Convert.ChangeType(item, targetType);
                        // }
                    }
                    else if ((typeof item === 'string')) {
                        if (String.isNullOrEmpty((item))) {
                            return this.nullToType(targetType);
                        }
                        // else if ((targetType == typeof (System.SByte))) {
                        //     let v: System.SByte;
                        //     if (System.SByte.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     TryParse((<string>(item)), /* out */v);
                        //     return v;
                        //     success = false;
                        //     return null;
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }
                        // }
                        // else if ((targetType == typeof (number))) {
                        //     let v: number;
                        //     if (number.TryParse((<string>(item)), /* out */v)) {
                        //         return v;
                        //     }
                        //     else {
                        //         success = false;
                        //         return null;
                        //     }
                        // }
                        // else if ((typeof targetType == 'number')) {
                        //     Number.parseInt
                        //     // let v: number;
                        //     // if (number.TryParse((<string>(item)), /* out */v)) {
                        //     //     return v;
                        //     // }
                        //     // else {
                        //     //     success = false;
                        //     //     return null;
                        //     // }
                        // }
                        // else {
                        //     //return convert.ChangeType(item, targetType);
                        // }
                    }
                }
                // else if ((targetType == typeof (Number))) {
                //     return Number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (System.SByte))) {
                //     return System.SByte.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return number.Parse(item.toString());
                // }
                // else if ((targetType == typeof (number))) {
                //     return;
                // }
                else if (typeof targetType == "number" && !general_1.isFloatType(targetType))
                    return Number.parseInt(item.toString());
                // else if (targetType == typeof(sbyte))
                //     return sbyte.Parse(item.ToString());
                // else if (targetType == typeof(byte))
                //     return byte.Parse(item.ToString());
                // else if (targetType == typeof (long))
                //     return long.Parse(item.ToString());
                // else if (targetType == typeof (short))
                //     return short.Parse(item.ToString());
                // else if (targetType == typeof (uint))
                //     return uint.Parse(item.ToString());
                // else if (targetType == typeof (ulong))
                //     return ulong.Parse(item.ToString());
                // else if (targetType == typeof (ushort))
                //     return ushort.Parse(item.ToString());
                // else if (targetType == typeof (double))
                //     return double.Parse(item.ToString());
                else if (typeof targetType == "number" && general_1.isFloatType(targetType))
                    return Number.parseFloat(item.toString());
                else if (typeof targetType == "boolean")
                    return "True".equals(item.toString());
                // else if (targetType == typeof (decimal))
                //     return decimal.Parse(item.ToString());
                else if (targetType instanceof DateTime_1.default)
                    return Date.parse(item.toString());
                // else if (targetType instanceof (TimeSpan))
                //     return TimeSpan.parse(DateTime.Parse(item.ToString()).ToString("HH:mm:ss"));
                else if (typeof item == 'string') {
                    // Assuming that the input is a CSV string and it needs to be split into multiple values list / array / dictionary
                    // if (targetType == typeof (string[]))
                    //     return ToArray<string>(item.ToString());
                    // else if (targetType == typeof (byte[]))
                    //     return ToArray<byte>(item.ToString());
                    // else if (targetType == typeof (int[]))
                    //     return ToArray<int>(item.ToString());
                    // else if (targetType == typeof (float[]))
                    //     return ToArray<float>(item.ToString());
                    // else if (targetType == typeof (double[]))
                    //     return ToArray<double>(item.ToString());
                    // else if (targetType == typeof (long[]))
                    //     return ToArray<long>(item.ToString());
                    // else if (targetType == typeof (bool[]))
                    //     return ToArray<bool>(item.ToString());
                    // else if (targetType == typeof (decimal[]))
                    //     return ToArray<decimal>(item.ToString());
                    // else if (targetType == typeof (object[]))
                    //     return ToArray<object>(item.ToString());
                    // else if (targetType == typeof (List<string>))
                    //         return ToList<string>(item.ToString());
                    // else if (targetType == typeof (List<byte>))
                    //         return ToList<byte>(item.ToString());
                    // else if (targetType == typeof (List<int>))
                    //         return ToList<int>(item.ToString());
                    // else if (targetType == typeof (List<float>))
                    //         return ToList<float>(item.ToString());
                    // else if (targetType == typeof (List<double>))
                    //         return ToList<double>(item.ToString());
                    // else if (targetType == typeof (List<decimal>))
                    //         return ToList<decimal>(item.ToString());
                    // else if (targetType == typeof (List<long>))
                    //         return ToList<long>(item.ToString());
                    // else if (targetType == typeof (List<bool>))
                    //         return ToList<bool>(item.ToString());
                    // else if (targetType == typeof (List<object>))
                    //         return ToList<object>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, string>))
                    //         return ToDictionary<string>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, byte>))
                    //         return ToDictionary<byte>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, int>))
                    //         return ToDictionary<int>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, float>))
                    //         return ToDictionary<float>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, double>))
                    //         return ToDictionary<double>(item.ToString());
                    // else if (targetType == typeof (Dictionary<string, decimal>))
                    //         return ToDictionary<decimal>(item.ToString());
                    // // else if (targetType == typeof(Dictionary<string, long>))
                    // //     return this.toDictionary<long>(item.ToString());
                    // else if (targetType instanceof Dictionary < sstring,)
                    //     return this.toDictionary<boolean>(item.ToString(), getType(item));
                    // else if (targetType == typeof (Dictionary<string, object>))
                    //         return ToDictionary<object>(item.ToString());
                }
            }
            else if (item == null)
                return this.nullToType(targetType);
            return item;
        }
        catch (Exception) {
            success.resolved = false;
            return this.nullToType(targetType);
        }
    }
    nullToTypeGeneric(tType) {
        return (this.nullToType(tType));
    }
    nullToType(targetType) {
        if ((typeof targetType == 'number')) {
            return 0;
        }
        // if ((targetType == typeof (number))) {
        //     return;
        // }
        // if ((targetType == typeof (number))) {
        //     return;
        // }
        // if ((targetType == typeof (number))) {
        //     return;
        // }
        // if ((targetType == typeof (number))) {
        //     return;
        // }
        // if ((targetType == typeof (number))) {
        //     return;
        // }
        // if ((targetType == typeof (number))) {
        //     return;
        // }
        // if ((targetType == typeof (number))) {
        //     return;
        // }
        // if ((targetType == typeof (number))) {
        //     return;
        // }
        // if ((targetType == typeof (number))) {
        //     return;
        // }
        if ((typeof targetType == 'boolean')) {
            return false;
        }
        if ((targetType instanceof (DateTime_1.default))) {
            return new DateTime_1.default();
        }
        if ((targetType instanceof (TimeSpan_1.default))) {
            return new TimeSpan_1.default(0);
        }
        return null;
    }
    /* virtual */ toArray(str, tType) {
        if (!(String.isNullOrEmpty(str) || String.isNullOrWhiteSpace(str))) {
            let items = new List_1.List();
            let tokens = this.splitValues(str);
            for (let token of tokens) {
                items.add((this.toType(token, tType, new outputVariables_1.outputVariables())));
            }
            return items.toArray();
        }
        return undefined;
    }
    /* virtual */ toList(str, tType) {
        if (!(String.isNullOrEmpty(str) || String.isNullOrWhiteSpace(str))) {
            let items = new List_1.List();
            let tokens = this.splitValues(str);
            for (const token of tokens) {
                items.add((this.toType(token.trim(), tType, new outputVariables_1.outputVariables())));
            }
            return items;
        }
        return undefined;
    }
    toDictionary(str, tType) {
        let outV = new outputVariables_1.outputVariables();
        if (!(String.isNullOrEmpty(str) || String.isNullOrWhiteSpace(str))) {
            let items = new dictionaryObject_1.DictionaryObject();
            let tokens = this.splitValues(str);
            for (const token of tokens) {
                let subTokens = token.split('=');
                items.add(subTokens[0], this.toTypeGeneric(subTokens[1], tType, outV));
            }
            return items;
        }
        return new dictionaryObject_1.DictionaryObject();
    }
    splitValues(str) {
        //return str.split(',', '\r', '\n', ';');
        return str.split(/,|\r|\n|;/);
    }
}
exports.defaultTypeMapper = defaultTypeMapper;
//# sourceMappingURL=defaultTypeMapper.js.map