"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EntityObject = void 0;
const dynamicObject_1 = require("./dynamicObject");
const List_1 = require("typescript-dotnet-commonjs/System/Collections/List");
const dictionaryObject_1 = require("../utils/dictionaryObject");
class EntityObject extends dynamicObject_1.dynamicObject {
    constructor(dict) {
        super();
        if (dict == null)
            this.dict = new dictionaryObject_1.DictionaryObject();
        else
            this.dict = dict;
    }
    getItem(key) {
        if (this.dict != null)
            return this.dict[key];
        else
            return undefined;
    }
    setItem(value, index) {
        if (this.dict != null)
            this.dict.setValue(index, value);
    }
    /* override */ getDynamicMemberNames() {
        if (this.dict != null) {
            let lstKyes = new List_1.default();
            for (let ke of this.dict.getKeys()) {
                lstKyes.add(ke);
            }
            return lstKyes;
        }
        else
            return undefined;
    }
}
exports.EntityObject = EntityObject;
//# sourceMappingURL=entityObject.js.map