"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGenericType = exports.getType = exports.getRuntimeProperties = exports.propertyInfo = void 0;
const dynamicObject_1 = require("./dynamicObject");
const general_1 = require("./general");
class propertyInfo {
    constructor() {
        this._name = "";
    }
    propertyType(setValue, propertyType) {
        throw new Error("Method not implemented.");
    }
    getIndexParameters() {
        return new propertyInfo();
    }
    getValue(context, arr = undefined) {
        if (arr == undefined) {
            if (typeof this.parameterType === "function") {
                return this.parameterType.call(this, context, context);
            }
            if (typeof context == 'string' || typeof context == 'number' || typeof context == 'boolean') {
                return context[this.name];
            }
            return general_1.getDirectProperty(context, this.name);
        }
        else {
            let result = undefined;
            if (context instanceof dynamicObject_1.dynamicObject) {
                for (let ar of arr) {
                    result = context.getItem(ar);
                }
            }
            return result;
        }
    }
    setValue(context, setValue) {
        general_1.setDirectProperty(context, this.name, setValue);
    }
    get type() {
        return this._type;
    }
    set type(v) {
        this._type = v;
    }
    get name() {
        return this._name;
    }
    set name(v) {
        this._name = v;
    }
}
exports.propertyInfo = propertyInfo;
function getRuntimeProperties(proType) {
    //console.log('Get runtime methods');
    let pros = [];
    Object.getOwnPropertyNames(proType).forEach((element) => {
        let pro = new propertyInfo();
        pro.name = element;
        // Object.getOwnPropertyDescriptor()
        pros.push(pro);
    });
    return pros;
}
exports.getRuntimeProperties = getRuntimeProperties;
function getType(val) {
    let data = val;
    return data;
}
exports.getType = getType;
function getGenericType(instance) {
    if (instance instanceof String)
        return getType(instance);
    else if (instance instanceof Number)
        return getType(instance);
    else if (instance instanceof Boolean)
        return getType(instance);
    else
        return getType(instance);
}
exports.getGenericType = getGenericType;
//# sourceMappingURL=reflectionExtender.js.map