﻿import expressionData from '../../expressionData';
import { groupDataContext } from '../../functions/groupDataContext';
import { Type } from 'typescript';
import { outputVariables } from '../../utils/outputVariables';

export abstract class expressionPart {

    abstract get simpleName(): string;
    constructor() {
    }

    get subParts(): expressionPart[] {
        return [];
    }
    abstract resolve(expressionData: expressionData, resolved: outputVariables, running?: groupDataContext, evaluateAllContexts?: boolean, setValue?: Object | undefined): Object | undefined;

    resolveClass(expressionData: expressionData, resolved: outputVariables, targetType: Type, running?: groupDataContext, evaluateAllContexts: boolean = true, setValue?: Object): Object | undefined {
        if (targetType != undefined) {
            let result: Object | undefined = this.resolve(expressionData, resolved, running, evaluateAllContexts, setValue);
            return result;
        }
        else {
            return this.resolve(expressionData, resolved, undefined, evaluateAllContexts, setValue);
        }
    }

    resolveGeneric<T>(expressionData: expressionData, resolved: outputVariables, tType: Type, running?: groupDataContext | undefined, evaluateAllContexts: boolean = true, setValue: Object | undefined = undefined): T {
        if (running == undefined) {
            let result: Object | undefined = this.resolveClass(expressionData, resolved, tType, running, evaluateAllContexts, setValue);

            return result as T;
        }
        else {
            return this.resolveGeneric<T>(expressionData, resolved, tType, undefined, evaluateAllContexts, setValue);
        }
    }
}