﻿import { expressionPart } from "./expressionPart";
import { groupDataContext } from "../../functions/groupDataContext";
import expressionData from "../../expressionData";
import { format } from "typescript-dotnet-commonjs/System/Text/Utility";
import { mfunction } from './../../functions/mfunction';
import List from "typescript-dotnet-commonjs/System/Collections/List";
import { outputVariables } from "../../utils/outputVariables";

export class functionCallPart extends expressionPart {

    constructor() {
        super();
    }
    get subParts(): expressionPart[] {
        return this.parameters;
    }

    function?: mfunction;

    parameters!: expressionPart[];

    get simpleName(): string {
        return (this.function as mfunction).functionName;
    }

    resolve(expressionData: expressionData, /* out */resolved: outputVariables, running: groupDataContext, evaluateAllContexts: boolean = true, setValue: Object | undefined = undefined): Object | undefined {
        if ((this.function != null)) {
            return this.function.invoke(expressionData, this.parameters, /* out */resolved, running);
        }

        resolved.resolved = false;
        return undefined;
    }

    toString(): string {
        return format("{0}({1})", (this.function as mfunction).functionName, this.parameters.join(", "));
    }
}
