﻿import { expressionPart } from "./expressionPart";
import { switchPartData } from "./switchPartData";
import expressionData from "../../expressionData";
import { groupDataContext } from "../../functions/groupDataContext";
import { outputVariables } from "../../utils/outputVariables";

export class switchCasePart extends expressionPart {

     get simpleName(): string {
        return "Switch";
    }

     get subParts(): expressionPart[] {
        let ep: expressionPart[] = [];
        ep.push(this.expression);

        this.switchData.Cases.forEach(item => {
            ep.push(item.key);
        });
        this.switchData.Cases.forEach(item => {
            ep.push(item.value);
        });

        return ep;
    }

    switchData!: switchPartData;
    expression!: expressionPart;

    resolve(expressionData: expressionData, resolved: outputVariables, running: groupDataContext, evaluateAllContexts: boolean = true, setValue: Object): Object | undefined {
        let result: Object | undefined = undefined;
        let value: Object | undefined = this.expression == null ? expressionData.contexts.peek() : this.expression.resolve(expressionData, resolved, running);

        result = this.switchData.forValue(expressionData, value as Object, resolved);
        return result;
    }
}
