﻿import {badExpressionException} from './badExpressionException'
import {format} from "typescript-dotnet-commonjs/System/Text/Utility"

export class invalidParametersException extends badExpressionException {
        
         constructor (methodName: string, minParams: number, maxParams: number){ 
                super(invalidParametersException.getErrorString(methodName, minParams, maxParams));
        }
        
            private static getErrorString(methodName: string, minParams: number, maxParams: number): string {
            if ((minParams == maxParams)) {
                if ((minParams == 0)) {
                    return format("Function '{0}' does not take parameters", methodName);
                }
                else {
                    return format("Function '{0}' requires {1} parameter(s)", methodName, minParams);
                }
                
            }
            else if (((minParams == -1) 
                        && (maxParams > 0))) {
                return format("Function '{0}' can not take more than {1} parameter(s)", methodName, maxParams);
            }
            else if (((maxParams == -1) 
                        && (minParams > 0))) {
                return format("Function '{0}' takes at least {1} parameter(s)", methodName, minParams);
            }
            
            return format("Invalid number of parameters for Function '{0}' should be between {1} - {2}", minParams, maxParams);
        }
    }