﻿import { mfunction } from './../mfunction'
import expressionData from '../../expressionData'
import { expressionPart } from './../../compiler/parts/expressionPart'
import { switchParameterPart } from './../../compiler/parts/switchParameterPart'
import { switchCasePart } from './../../compiler/parts/switchCasePart'
import { utils } from './../../compiler/utils'
import { List } from 'typescript-dotnet-commonjs/System/Collections/List'
import { groupDataContext } from './../../functions/groupDataContext'
import { compileFlags } from '../../compiler/expressionCompiler'
import { outputVariables } from '../../utils/outputVariables'


export class aswitch extends mfunction {

     /* override */ get minParameters(): number {
        return 1;
    }

     /* override */ get maxParameters(): number {
        return -1;
    }

     compileParameters(paramList: List<string>, flags: compileFlags) : expressionPart[] {
        let parameters: expressionPart[] = [];
        let switParameter = new switchParameterPart();
        flags.switchCasePart = true;
        let compileOjbect = new compileFlags(flags);
        compileOjbect.switchCasePart = true;
        switParameter.switchData = utils.buildSwitchCaseOverload(paramList, compileOjbect);
         //switParameter.switchData = true;
        parameters.push(switParameter);
        return parameters;
    }

     invoke(expressionData: expressionData, parameters: expressionPart[], /* out */resolved: outputVariables, running: groupDataContext): Object | undefined {
        if (parameters[0] instanceof switchParameterPart) {
            let part: switchParameterPart = (<switchParameterPart>parameters[0]);
            return part.resolve(expressionData, /* out */resolved, /* running:*/ running);
        }
        else {
           resolved.resolved = false;
            return undefined;
        }

    }
}