﻿type invoke = (values: Object[]) => Object | undefined;
export interface operator {

    precedence?: number;

    name?: string;

    invoke: invoke;
}

export interface IMethodCall {
    (values: Object[]): Object | undefined
}

export abstract class op<In, Out> implements operator {

    abstract precedence: number;

    name?: string;

    canCutOff?: <In, Boolean>() => {};

    opInvoke!: (v: Object[]) => Object | undefined | null;

    invoke(values: Object[]): Object | undefined {
        if ((values == null)) {
            return undefined;
        }

        let ins: In[] = new Array(values.length);
        if ((ins == null)) {
            return undefined;
        }

        for (let i: number = 0; (i < values.length); i++) {
            ins[i] = (<In>(values[i]));
        }

        return this.opInvoke(values) as Object | undefined
    }

         /* override */ toString(): string | undefined {
        return this.name;
    }
}