﻿// iTypeMapper.ts
import { List } from 'typescript-dotnet-commonjs/System/Collections/List'
import { Type } from 'typescript'
import { outputVariables } from '../utils/outputVariables'
import { DictionaryObject } from '../utils/dictionaryObject'

export interface iTypeMapper {

    nullToTypeGeneric<T>(tType: Type): T | undefined;

    nullToType(targetType: Type): Object | undefined;

    toTypeGeneric<T>(item: Object, tType: Type, success: outputVariables): T;

    //nullToAny(targetType: any): Object | undefined;

    // toType<T>(item: Object): T | undefined;

    // toType2<T>(item: Object, /* out */success: boolean): T | undefined;

    // toType3<T>(item: Object, targetType: any,tType: Type): Object | undefined;

    toType(item: Object, targetType: any, success: outputVariables): Object | undefined;

    toArray<T>(str: string, tType: Type): T[] | undefined;

    toList<T>(str: string, tType: Type): List<T> | undefined;

    toDictionary<T>(str: string, tType: Type): DictionaryObject | undefined;
}
