import { dynamicObject } from "./dynamicObject";
import List from "typescript-dotnet-commonjs/System/Collections/List";
import { DictionaryObject as Dictionary } from '../utils/dictionaryObject';

export class EntityObject extends dynamicObject {

    private dict?: Dictionary;

     constructor(dict?: Dictionary) {
        super();
        if (dict == null)
            this.dict = new Dictionary();
        else
            this.dict = dict;
    }

     getItem(key: string): Object | undefined {
        if (this.dict != null)
            return this.dict[key];
        else
            return undefined;
    }
     setItem(value: Object, index: string) {
        if (this.dict != null)
            this.dict.setValue(index, value);
    }

     /* override */ getDynamicMemberNames(): List<string> | undefined {
        if (this.dict != null) {
            let lstKyes = new List<string>();
          
            for (let ke of this.dict.getKeys()) {
                lstKyes.add(ke);
            }
            return lstKyes;
        }
        else return undefined;
    }
}