import { expressionEngine } from "../../src/expressionEngine";
import { expect } from "chai";
import { getType } from "../../src/utils/reflectionExtender";
import { testContext, getContext } from "../testContext";

describe('  Expression engine - Operator - tilda', () => {
    it('Case 1 - pass case', () => {

        let context: testContext = getContext();
        context.FirstString = "http://www.google.com";
        context.SecondString = "www.google.com";
        let result: boolean = expressionEngine.evalGeneric<boolean>(context, "\"//\" ~ FirstString");
        expect(true).to.equal(result);
    });

    it('Case 2 - pass case', () => {

        let context: testContext = getContext();
        context.FirstString = "http://www.google.com";
        context.SecondString = "www.google.com"
        let result: boolean = expressionEngine.evalGeneric<boolean>(context, "\"//\" ~ SecondString");
        expect(false).to.equal(result);
    });

    it('Case 3 - pass case', () => {

        let context: testContext = new testContext();
        context.ThirdString = "http://www.google.com";
        context.FourString = "www.google.com"
        let result: string = expressionEngine.evalGeneric<string>(context, "(\"//\" ~ FourString){true=FourString, false=\"http://\" + FourString}");
        expect("http://www.google.com").to.equal(result);
    });
});

describe('  Expression engine - Operator - hash', () => {
    it('Case 1 - pass case', () => {

        let result: boolean = expressionEngine.evalGeneric<boolean>(undefined, "\"a\" # \"abc\"");
        expect(true).to.equal(result);
    });

    it('Case 2 - pass case', () => {

        let result: boolean = expressionEngine.evalGeneric<boolean>(undefined, "\"a\" # \"ABC\"");
        expect(false).to.equal(result);
    });

    it('Case 3 - pass case', () => {

        let result: boolean = expressionEngine.evalGeneric<boolean>(undefined, "\"a\" % \"abc\"");
        expect(true).to.equal(result);
    });

    it('Case 4 - pass case', () => {

        let result: boolean = expressionEngine.evalGeneric<boolean>(undefined, "\"a\" % \"ABC\"");
        expect(true).to.equal(result);
    });
});